

//*****************************************************************************
//	   Adams-Bashforth-Moulton@(12)ɂHalleyâm̐ϕvO(Adams3)
//       ver. 1.0   2015/05/29   by takesako@mrj.biglobe		
//*****************************************************************************

//@̃vO͈ȉ̕/\[XQlɂĂ܂B
//@EuV̂̋OvZv꒘AV(1992)
//@@@т̃\tg/\[X@lbc(p290-p295)
//    @ (ϐ/z񖼓̂܂܎gĂ܂)
//@EuV(f/)̈ʒuZyї\̌vZ\tg/\[X mhodv@
//@@@(V3.21 1997/11/03)@by m[oX 
//@@@(Adams-Bashforth-Moulton@(12)NIPEڐA܂B)
//@Eup\RŌV̂̓vJHAGRqAnl(1992)
//  EuEXPLANATORY SUPPLEMENT to the ASTRONOMICAL ALMANACv
//@@@@U.S.NAVAL OBSERVATORY, UVLERSITY SCIENCE BOOKS(1992)
//     @(DE200̏lyьvZ̉)
//@EuThe Planetary and Lunar Ephemerides DE430 and DE431v
//   @@William M. Folkner,* James G. Williams, Dale H. Boggs,
//	 @  Ryan S. Park, and Petr Kuchynka(2014/02/15)
//     @(f̏l͂̕gpĂ܂B)
//

#include <math.h>
#include <stdio.h>
#include "jpl_eph.h"
#include <time.h>

#define MULT(a,b) (a[1]*b[1]+a[2]*b[2]+a[3]*b[3]) // xNg̓όvZ̒`
#define MAXN   17         //ϕV̐̒`@16̏ꍇz`(10)++f5
#define MAX_NI 17         //ϕV̐Ɠ
#define NIORD  12         //ϕ
#define NIDAY (NIORD+4)   //ϕ+[NGA
#define ADAMS  20         //ADAMŠWvZ鎟
#define NISTP  8          //ϕXebv@

//Tu[`̒`
void ni_Runge_Kutta_exec(FILE *fp_Bin,int NG,double DAY,double EPOCH,int NBODY,double GMASS[MAXN] ,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double CD1[MAXN][MAXN]);//QNb^@ɏlvZ[`
void ni_Adams_init(double APcf[ADAMS], double ACcf[ADAMS] );//	A_X̐lϕ@W̌vZ
void ni_Predict_Adams(double h,int p,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double APcf[ADAMS] );//	A_X̐lϕ@(\)
void ni_Correct_Adams(double h,int p,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double ACcf[ADAMS]);//	A_X̐lϕ@(C)
int ni_Adams_exec(int NG, double t,double EPOCH,int p,int NBODY,double GMASS[MAXN],double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double APcf[ADAMS],double ACcf[ADAMS],double CD1[MAXN][MAXN],double MIN[MAXN][2]);	// return:̐ϕ[Ñ|C^[ 
void PERN(double EPOCH, int NG, int NBODY, int I,double GMASS[MAXN] ,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double CD1[MAXN][MAXN]);// m̐ϕɂx̌vZ(d͌ʕt)	
void NonGravity(int I, int M, double A1,double A2,double NGr[4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double CD1[MAXN][MAXN]);// d͌ʂ̌vZ
void CDINI_file(FILE *fp_Bin, double EPOCH ,int I, double CD[NIDAY][MAXN][4], double VL[NIDAY][MAXN][4],double GMASS[MAXN], int NBODY);//f[^̓ǂݍ
void DE_data(FILE *fp_Bin, double EPOCH ,int I, double CD[NIDAY][MAXN][4], double VL[NIDAY][MAXN][4]);//z/f/̈ʒuExf[^DE431t@Cǂݍރ[`
void Calendar( double juday, double *year,double *month,double *day,double *hour,int LST,double longitude);

FILE  *fth,*optr,*ftp,*fp_Bin,*ttp;

void main(void)
{
	double GMASS[MAXN],PER[NIDAY][MAXN][4],CD[NIDAY][MAXN][4],VL[NIDAY][MAXN][4], CD1[MAXN][MAXN];
    //     dʁ@@@@x@@@@@@@ʒu@@@@@@@@x@@@@@@@ V̊Ԃ̋@
	double AA[MAXN][4],VV[MAXN][4]; // ʒuƑx̃[NGA
	double MIN[MAXN][2];//n[aƓV̂̍Őڋߋ[M][0]Ɠ[M][1]i[
	double EPOCH,DAY,TEPOCH;
	double	SFLDAY,B,DayMax;
	double APcf[ADAMS], ACcf[ADAMS]; //adamšWi[
	double year,month,day,hour, longitude=0.0,L1=0.0,L2=0.0;
	int 	I,M,N,NBODY;
	int LST=0, DE,NG,p;
    time_t start_time,end_time,now;//Ԍvp


	 start_time= time(&now);//sԌvJn

// JPL̈ʒu/xf[^t@CI[v
    DE=431; // DE431gp
	fp_Bin=INITIAL(DE);

//  vZʂރt@C(eLXg)I[v
	ftp= fopen ("data.csv","wt");//SFLDAŸʒuL^
	fth= fopen ("halley.csv","wt");//񖈂̘fւ̍ŐڋߋL^

	NBODY=MAXN-1; // 0(MAXN-1)܂MAXN̔z𑀍삷̂Ɏgp

//	z̏;
	for ( M=0; M<=NBODY; M++){
		MIN[M][0]=1000.0;
		MIN[M][1]=0.0;
		for ( N=0; N<=3; N++){
			for (I=0; I<=NIDAY-1; I++){
				PER   [I][M][N]=0.0;
				CD    [I][M][N]=0.0;
				VL    [I][M][N]=0.0;
				AA[M][N]       =0.0;
				VV[M][N]       =0.0;
			}
		}
	}

// 	vZ̕`B@+̏ꍇlOiB-͌ށB
	B=-4.0;//B=-4̏ꍇ4/NISTEP(8)=0.5XebvŌvZB0.125XebvŌvZꍇB=-1.0ƂB

//	vZSTEP(Ԋu)̒`
	DAY=B/(double)NISTP;

//@vZ̓(l̓t̓)
//	DayMax=365.0*78.0*40; //n[a40̌vZ
	DayMax=365.25*3500; //3500ŇvZ

//  ʕ\/t@Cւ̏݊Ԋu
	SFLDAY=5000.0;//5000ɏ

// 	d͌ʂ̌vZ̗L(NG=1)/(NG=0)
	NG=1;

//	f/f̏l̐ݒ
//	EPOCH̏@1. ( 2370000.5(AD1776/9/27)< jd < 2490000.5(2105/4/16) )
//               2. (jd-0.5)4̔{
	EPOCH=2446472.5000;
	CDINI_file(fp_Bin, EPOCH , 0, CD, VL, GMASS, NBODY);

//	f/f̏l̕\
	printf("\n");
	printf("@@lf[^@ jd=%12.3f\n",EPOCH);
	for( M=0; M<=NBODY; M++){
		printf(" CD[1] %2d %20.12f %20.12f %20.12f \n", M, CD[0][M][1], CD[0][M][2], CD[0][M][3]);
		printf(" VL[1] %2d %20.12f %20.12f %20.12f \n", M, VL[0][M][1], VL[0][M][2], VL[0][M][3]);
	}
	printf("\n");

// 	l̓tTEPOCHɊi[
	TEPOCH=EPOCH;

//	A_Xlϕ@@W̌vZ
	ni_Adams_init( APcf, ACcf );

//@lϕƂ͋t12Xebv(p=1`12)̒lQNb^ŌvZB
	ni_Runge_Kutta_exec( fp_Bin,NG,(-1.0)*DAY, EPOCH, NBODY, GMASS , PER, CD, VL,CD1);//QNb^@ɂN̐ϕ̏ݒ胋[`

	// p (0`15)͔z(CD:ʒu,VL:x,PER:x)̍ŏI(EPOCH)̌vZ|CgB
	p=0;

	while(1){

//	***  I(SFLDAY)Ƀt@Cɏރ[`***
	if(fmod((EPOCH-TEPOCH),SFLDAY) == 0.0) {			
	Calendar(EPOCH,&year,&month,&day,&hour,LST,longitude);
	printf     ("EPOCH=%12.3f :  %5.0f/%2.0f/%2.0f\n",EPOCH,year,month,day);
	fprintf(ftp,"EPOCH=%12.3f :  %5.0f/%2.0f/%2.0f\n",EPOCH,year,month,day);
	for( M=0; M<=16; M++){
//		printf     (" %2d, %20.15f, %20.15f, %20.15f, \n",p, CD [p][M][1], CD [p][M][2], CD [p][M][3]);//ʒu
//		printf     (" %2d, %20.15f, %20.15f, %20.15f, \n",p, VL [p][M][1], VL [p][M][2], VL [p][M][3]);//x
//		printf     (" %2d, %20.15f, %20.15f, %20.15f, \n",p, PER[p][M][1], PER[p][M][2], PER[p][M][3]);//x
		fprintf(ftp," %2d, %20.15f, %20.15f, %20.15f, \n",M, CD [p][M][1], CD [p][M][2], CD [p][M][3]);//ʒu
//		fprintf(ftp," %2d, %20.15f, %20.15f, %20.15f, \n",I, VL [p][M][1], VL [p][M][2], VL [p][M][3]);//x
//		fprintf(ftp," %2d, %20.15f, %20.15f, %20.15f, \n",I, PER[p][M][1], PER[p][M][2], PER[p][M][3]);//x
		}
	}
//	***  I(SFLDAY)Ƀt@Cɏރ[`(܂) ***


	// 8STEP̒lAdams-Bashforth-Moulton@ŌvZB
	// ŏP=0ɏlAQNb^P=1`12܂ŋt12STEP̌vZlĂB
	// ŏp=0ni_Adams_exec()̌vZŁAP=15`P=88Xebv̌vZlP=8ŕԂĂB
	// @p=8ni_Adams_exec()̌vZŁAP= 7`P=08Xebv̌vZlP=0ŕԂĂB
	// ȍ~̌JԂB

	p=ni_Adams_exec( NG, B,EPOCH, p, NBODY, GMASS, PER, CD, VL, APcf, ACcf,CD1,MIN);	 


//	*** ɑz/f//fƂ̍Őڋߋ̋L^t@Cɏ ***

	L1=CD1[16][0]; // L1FŐṼn[Ezԋ L2:BŐ
	if(L1>9.0 && L2<9.0) // 9VPʗ鋫EŃf[^̕\/
	{
		Calendar( EPOCH, &year,&month,&day,&hour,0,0);
		printf("Position on %5.0f/%2.0f/%3.1f: JD= %.6f ; Adams-Bashforth-Moulton, step= %8.5f day; L1=%5.2f\n", year,month,day,EPOCH,DAY,L1);
		fprintf(fth,"Position on %5.0f/%2.0f/%3.1f: JD= %.6f ; Adams, step= %8.5f day; L1=%5.2f\n", year,month,day,EPOCH,DAY,L1);
		for(M=0;M<NBODY;M++){
		Calendar( MIN[M][1], &year,&month,&day,&hour,0,0);
		printf(     "%2d, %8.5f, %10.3f, %5.0f/%2.0f/%2.0f\n",M,MIN[M][0],MIN[M][1],year,month,day);
		fprintf(fth,"%2d, %8.5f, %10.3f, %5.0f/%2.0f/%2.0f\n",M,MIN[M][0],MIN[M][1],year,month,day);
		}
		for(M=0;M<NBODY;M++){
		MIN[M][0]=1000.0;
		MIN[M][1]=0.0;
		}
		L2=L1;
	}
	 else L2=L1;
//	*** ɑz/f//fƂ̍Őڋߋ̋L^t@Cɏ(܂) ***

//	+Bɐi
	EPOCH=EPOCH+B;//BWSTEPŌvZĂB

// 	ȉ̏Ń[v𔲂
	if(B>0)if(EPOCH>TEPOCH+DayMax) break;
	if(B<0)if(EPOCH<TEPOCH-DayMax) break;

	}

	end_time= time(&now);//I
    printf("\n vOs [%d SEC] \n\n", end_time-start_time);//sԂ̕\
    fprintf(fth,"\n vOs [%d SEC] \n\n", end_time-start_time);//sԂ̕\

	//****************************************
	fclose(fp_Bin);
	fclose(ftp);
	fclose(fth);


}

//*********************************************************************
// QNb^@ɏlvZ[` (12step̌vZ)
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************

void ni_Runge_Kutta_exec(FILE *fp_Bin,int NG,double DAY,double EPOCH,int NBODY,double GMASS[MAXN] ,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double CD1[MAXN][MAXN])
{
	int i,k,n,I;
	double A,V;

	/* f̏ʒǔvZ */
	for(i=0;i<NIORD;i++){
//		printf("f̏ʒu(%d)\n",i+1);
    I=i+0;  // lɂiڂ̉x̌vZ
	PERN ( EPOCH, NG, NBODY, I, GMASS , PER, CD, VL,CD1);
	
	for(k=0;k<MAX_NI;k++){
			for(n=1;n<=3;n++){
				VL[i+1][k][n]=VL[i+0][k][n]+PER[i+0][k][n]*DAY/2.0;
				CD[i+1][k][n]=CD[i+0][k][n]+VL[i+0][k][n]*DAY/2.0;
			}
		}

	I=i+1;  // lɂ2iڂ̉x̌vZ
	PERN ( EPOCH, NG, NBODY, I, GMASS , PER, CD, VL,CD1);

		for(k=0;k<MAX_NI;k++){
			for(n=1;n<=3;n++){
				VL[i+2][k][n]=VL[i+0][k][n]+PER[i+1][k][n]*DAY/2.0;
				CD[i+2][k][n]=CD[i+0][k][n]+VL[i+1][k][n]*DAY/2.0;
			}
		}
    I=i+2;  // lɂ3iڂ̉x̌vZ
	PERN ( EPOCH, NG, NBODY, I, GMASS , PER, CD, VL,CD1);

	for(k=0;k<MAX_NI;k++){
			for(n=1;n<=3;n++){
				VL[i+3][k][n]=VL[i+0][k][n]+PER[i+2][k][n]*DAY;
				CD[i+3][k][n]=CD[i+0][k][n]+VL[i+2][k][n]*DAY;
			}
		}
    I=i+3;  // lɂ3iڂ̉x̌vZ
	PERN ( EPOCH, NG, NBODY, I, GMASS , PER, CD, VL,CD1);

		for(k=11;k<MAX_NI;k++){ //f̂݉
			for(n=1;n<=3;n++){
				A =    PER[i+0][k][n];
				A+=2.0*PER[i+1][k][n];
				A+=2.0*PER[i+2][k][n];
				A+=    PER[i+3][k][n];
				A/=6.0;

				V =    VL[i+0][k][n];
				V+=2.0*VL[i+1][k][n];
				V+=2.0*VL[i+2][k][n];
				V+=    VL[i+3][k][n];
				V/=6.0;

				VL[i+1][k][n]=VL[i][k][n]+A*DAY;
				CD[i+1][k][n]=CD[i][k][n]+V*DAY;
			}
		}
	DE_data(fp_Bin, EPOCH+DAY*(double)(i+1) , i+1, CD, VL);//zEfEDE431t@Cǂݍ

	}

    I=i+1;  // lɂiڂ̉x̌vZ
	PERN ( EPOCH, NG, NBODY, I, GMASS , PER, CD, VL,CD1);

	return;
}

//*********************************************************************
//	A_X̐lϕ@W̌vZ
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************

void ni_Adams_init(double APcf[ADAMS], double ACcf[ADAMS] )
{
	int i,j;

	// W̌vZ 
	APcf[0]=ACcf[0]=1.0;
	for(i=1;i<ADAMS;i++){
		APcf[i]=1.0;
		for(j=i;j>0;j--)APcf[i]-=APcf[j-1]/(double)(i-j+2);
		ACcf[i]=0.0;
		for(j=i;j>0;j--)ACcf[i]-=ACcf[j-1]/(double)(i-j+2);
	}
}

//*********************************************************************
//	A_X̐lϕ@(\)
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************
void ni_Predict_Adams(double h,int p,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double APcf[ADAMS] )
{
	int j,k,m,n;
	double A,V;
	double Adif[NIORD][NIORD],Vdif[NIORD][NIORD];

	for(k=11;k<MAX_NI;k++){ //fȍ~̂݌vZ
		for(n=1;n<=3;n++){
			for(j=0;j<NIORD;j++)Adif[0][j]=PER[(p+j+1)%NIDAY][k][n];
			for(j=1;j<NIORD;j++)for(m=0;m<(NIORD-j);m++){
				Adif[j][m]=Adif[j-1][m]-Adif[j-1][m+1];
			}
			A=0.0;
			for(j=0;j<NIORD;j++)A+=APcf[j]*Adif[j][0];
			VL[p][k][n]=VL[(p+1)%NIDAY][k][n]+A*h;
		}
	}
	for(k=11;k<MAX_NI;k++){ //fȍ~̂݌vZ
		for(n=1;n<=3;n++){
			for(j=0;j<NIORD;j++)Vdif[0][j]=VL[(p+j+1)%NIDAY][k][n];
			for(j=1;j<NIORD;j++)for(m=0;m<(NIORD-j);m++){
				Vdif[j][m]=Vdif[j-1][m]-Vdif[j-1][m+1];
			}
			V=0.0;
			for(j=0;j<NIORD;j++)V+=APcf[j]*Vdif[j][0];
			CD[p][k][n]=CD[(p+1)%NIDAY][k][n]+V*h;
		}
	}
	return;
}

//*********************************************************************
//	A_X̐lϕ@(C)
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************
void ni_Correct_Adams(double h,int p,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double ACcf[ADAMS])
{
	int j,k,m,n;
	double A,V;
	double Adif[NIORD][NIORD],Vdif[NIORD][NIORD];

	for(k=11;k<MAX_NI;k++){ //fȍ~̂݌vZ
		for(n=1;n<=3;n++){
			for(j=0;j<NIORD;j++)Adif[0][j]=PER[(p+j)%NIDAY][k][n];
			for(j=1;j<NIORD;j++)for(m=0;m<(NIORD-j);m++){
				Adif[j][m]=Adif[j-1][m]-Adif[j-1][m+1];
			}
			A=0.0;
			for(j=0;j<NIORD;j++)A+=ACcf[j]*Adif[j][0];
			VL[p][k][n]=VL[(p+1)%NIDAY][k][n]+A*h;
		}
	}
	for(k=11;k<MAX_NI;k++){ //fȍ~̂݌vZ
		for(n=1;n<=3;n++){
			for(j=0;j<NIORD;j++)Vdif[0][j]=VL[(p+j)%NIDAY][k][n];
			for(j=1;j<NIORD;j++)for(m=0;m<(NIORD-j);m++){
				Vdif[j][m]=Vdif[j-1][m]-Vdif[j-1][m+1];
			}
			V=0.0;
			for(j=0;j<NIORD;j++)V+=ACcf[j]*Vdif[j][0];
			CD[p][k][n]=CD[(p+1)%NIDAY][k][n]+V*h;
		}
	}
	return;
}

//*********************************************************************
//	A_X̐lϕ@^s
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************
int ni_Adams_exec(int NG, double t,double EPOCH,int p,int NBODY,double GMASS[MAXN],double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double APcf[ADAMS],double ACcf[ADAMS],double CD1[MAXN][MAXN],double MIN[MAXN][2])	// return:̐ϕ[Ñ|C^[ 
{
	int i,M;
	double h;
	h=t/(double)NISTP;

	for(i=0;i<NISTP;i++){
		if(p>0)	p--;
		else	p=NIDAY-1;
		ni_Predict_Adams( h, p, PER, CD, VL, APcf);
	    DE_data(fp_Bin, EPOCH+h*(double)(i+1) ,p, CD, VL);//zEfE͂cdt@Cǂݍ
		PERN ( EPOCH, NG, NBODY, p, GMASS , PER, CD, VL,CD1);
		ni_Correct_Adams( h, p, PER, CD, VL, ACcf);
	    DE_data(fp_Bin, EPOCH+h*(double)(i+1) ,p, CD, VL);//zEfE͂cdt@Cǂݍ
		PERN (  EPOCH, NG,NBODY, p, GMASS , PER, CD, VL,CD1);
		
	//efƂ̍ŐڋߋEtL^
	for ( M=0; M<=NBODY; M++)if(CD1[16][M]<MIN[M][0]){MIN[M][0]=CD1[16][M];MIN[M][1]=EPOCH+h*(double)(i+1);}
	}
	return p;
}

//*********************************************************************
// fEf̏f[^̐ݒ
//*********************************************************************
void CDINI_file(FILE *fp_Bin, double EPOCH ,int I, double CD[8][MAXN][4], double VL[8][MAXN][4],double GMASS[MAXN], int NBODY)
{
	int M,N;
	double GAUSS,GAUSS2,AMASS[MAXN];
	double BB[5][7];
	double SFLDAY,TC,TC2,AFLDAY;
	int		IREC;
	

//	l̒` ( 2370000.5< jd < 2490000.5 )
	if(EPOCH< 2370000.5 || EPOCH> 2490000.5){ 
		printf("@EPOCH=%12.3f ͏l͈̔͊Oł\n",EPOCH);
		return;
	}

// 	jdɂ鑾z/f/̓ǂݍ
	DE_data(fp_Bin, EPOCH, I, CD, VL);

// 	f̃p[^̓ǂݍ݁BiznS̈ʒuj
	optr= fopen ("mp5n.dat","rb");//VKff[^t@C
	fseek(optr,0,0);
	fread(BB,sizeof(BB),1,optr);
	SFLDAY=BB[0][0];
	fseek(optr,sizeof(BB),0);
	fread(BB,sizeof(BB),1,optr);
	TC2=BB[0][0];
	
	AFLDAY=TC2-SFLDAY;
	IREC=(int)(( EPOCH-SFLDAY)/AFLDAY+1.00001);

	fseek(optr,sizeof(BB)*(IREC-1),0);
	fread(BB,sizeof(BB),1,optr);
	
	TC=BB[0][0];//f[^̓t̊mF
	if( EPOCH!=TC)printf("File read error");

	for ( M=0; M<5; M++){
	CD[I][11+M][1]=BB[M][1];
	CD[I][11+M][2]=BB[M][2];
	CD[I][11+M][3]=BB[M][3];
	VL[I][11+M][1]=BB[M][4];
	VL[I][11+M][2]=BB[M][5];
	VL[I][11+M][3]=BB[M][6];
//	printf( " %2d, %13.9f, %13.9f, %13.9f, %13.9f, %13.9f, %13.9f\n",M,BB[M][1],BB[M][2],BB[M][3],BB[M][4],BB[M][5],BB[M][6]);
	}

// 	f/Əf̑zƂ̏dʔ`
	AMASS[ 0]=1.0/1.000000;			// Sun
	AMASS[ 1]=1.0/6023682.155592;	// Mercury
	AMASS[ 2]=1.0/408523.718658;	// Venus
	AMASS[ 3]=1.0/332946.048834;	// Earth
	AMASS[ 4]=1.0/3098703.590291;	// Mars
	AMASS[ 5]=1.0/1047.348625;		// Jupiter
	AMASS[ 6]=1.0/3497.901768;		// Saturn
	AMASS[ 7]=1.0/22902.981613;		// Uranus
	AMASS[ 8]=1.0/19412.259776;		// Neptune
	AMASS[ 9]=1.0/135836683.768617;	// Pluto
	AMASS[10]=1.0/27068703.241203;	// Moon
	AMASS[11]=4.73E-10;				//	1	Ceres*
	AMASS[12]=1.05E-10;				//	2	Pallas*
	AMASS[13]=1.30E-10;				//	4	Vesta*
	AMASS[14]=4.18E-11;				//	10	Hygiea*
	AMASS[15]=1.58E-11;				//  15	Eunomia*

// Halley EPOCH=2446468.5000 comet catalogue (1997)
//2446470.95890000
//111.86570000
// 58.86010000
//162.24220000
//  0.58710400
//  0.96727700
//Px=   0.5638904 Py=  -0.8244000 Pz=  -0.0489110
//Qx=  -0.7835064 Qy=  -0.5153187 Qz=  -0.3472238
//EPOCH=2446472.5000

CD[I][16][1]= 0.292488509596; CD[I][16][2]=-0.508161688283; CD[I][16][3]=-0.045506195962;
VL[I][16][1]=-0.025373343081; VL[I][16][2]=-0.015110455835; VL[I][16][3]=-0.010850178120;
AMASS[16]=0.0;

// znSɈړ
for(N=1;N<=3;N++){
		CD[I][16][N]=CD[I][16][N]+CD[I][0][N];
		VL[I][16][N]=VL[I][16][N]+VL[I][0][N];
	}

//	astronomical constants
	GAUSS =0.01720209895e0;
	GAUSS2=GAUSS*GAUSS;

//	planetary mass for DE431
	for ( M=0; M<= NBODY; M++){
		GMASS[M]=AMASS[M]*GAUSS2;
//		printf("%20.10E\n",GMASS[M]);
	}
}

//****************************************************************
// d͌ʂ̌vZ	(uV̋O_v@p329-330Q)
// A3iOʂɐj,B1/B2/B3(ԕω)͖(0)ƂB
//****************************************************************

	void NonGravity(int I, int M, double A1,double A2,double NGr[4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double CD1[MAXN][MAXN])
{
	double x,y,z,vx,vy,vz,r,a,r0,m,n,k,Gr,F1,F2,vr,h;
		
	//V̂̈ʒu
	x=CD[I][M][1]; //V(M)̈ʒu
	y=CD[I][M][2];
	z=CD[I][M][3];
	vx=VL[I][M][1];//V(M)̑x
	vy=VL[I][M][2];
	vz=VL[I][M][3];
	r=CD1[0][M];   //z(0)ƓV(M)̋

	//g(r)=GřvZ
	a=0.111262; //
	r0=2.808;
	m=2.15;
	n=5.093;
	k=4.6142;
	Gr=a*pow(r/r0,-m)*pow(1.0+pow(r/r0,n),-k);
	//F1,F2W̌vZ
	F1=A1*1.0e-8*Gr;
	F2=A2*1.0e-8*Gr;
	
	vr=(x*vx+y*vy+z*vz)/r;
	h=sqrt(pow(y*vz-z*vy,2)+pow(z*vx-x*vz,2)+pow(x*vy-y*vx,2));

	//d͌
	NGr[1]=F1*x/r+F2*(r*vx-x*vr)/h;
	NGr[2]=F1*y/r+F2*(r*vy-y*vr)/h;
	NGr[3]=F1*z/r+F2*(r*vz-z*vr)/h;
}

//****************************************************************
// m̐ϕɂx̌vZ	
//****************************************************************

 	void PERN(double EPOCH, int NG, int NBODY, int I,double GMASS[MAXN] ,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double CD1[MAXN][MAXN])
{
	double DIRECT[MAXN][MAXN][4],PER0[MAXN][4];
	double CDD[MAXN][MAXN][4],CD2[MAXN][MAXN],c;
	double U[MAXN][MAXN],SU[MAXN];
	double a10,a11,a12,a13,a14,a15,a16,a16_0,a17;
	double a20[4],a21[4],a22[4],a30[4];
	double NGr[4],A1,A2;
	int		i,j,N;	
	
	c=299792.458*24.0*3600.0/1.495978070e8; // Speed of Light (AU/DAY)


	for ( i=0; i<=NBODY; i++){
		for ( j=0; j<=NBODY; j++){
			if(i!=j){
				for(N=1;N<=3;N++)CDD[i][j][N]=CD[I][j][N]-CD[I][i][N];
				CD2[i][j]=MULT(CDD[i][j],CDD[i][j]);
				CD1[i][j]=sqrt(CD2[i][j]);
				U[i][j]=GMASS[j]/CD1[i][j];
				for(N=1;N<=3;N++)DIRECT[i][j][N]=CDD[i][j][N]*U[i][j]/CD2[i][j];
			}
		}
	}

		for (i=0;i<=NBODY;i++){
			for(N=1;N<=3;N++)PER0[i][N]=0.0;
			SU[i]=0.0;
			for( j=0;j<=NBODY;j++){
				if(i  !=  j){
				SU[i]=SU[i]+U[i][j];
				for(N=1;N<=3;N++)PER0[i][N]=PER0[i][N]+DIRECT[i][j][N];
				}
		}
	}

//		ʂ̉eꍇɎgp		
//		if(I==1){
//		for(i=0;i<=NBODY;i++){
//		for(j=0;j<=NBODY;j++){
//		printf("%2d %2d %15.12f %15.12f %12.12f\n",i,j,DIRECT[i][j][1],DIRECT[i][j][2],DIRECT[i][j][3]);
//		}
//		}
//		}


// j[g͊ŵݎgpꍇ(ΐ_xȍ~̓RgAEg)
// PER0[][][]̓j[g͊w̉x
//for (i=0;i<=NBODY;i++){
//			for(N=1;N<=3;N++)PER[I][i][N]=0.0;
//			for( j=0;j<=NBODY;j++){
//				if(i  !=  j){
//				for(N=1;N<=3;N++)PER[I][i][N]=PER[I][i][N]+DIRECT[i][j][N];
//				}
//		}
//	}
	
// ΐ_x@P

		for (i=11;i<=NBODY;i++){
		for( j=0;j<=NBODY;j++){
			if(i  !=  j){
			a11=-4.0*SU[i];
			a12=-1.0*SU[j];
			a13= MULT(VL[I][i],VL[I][i]);
			a14= 2.0*MULT(VL[I][j],VL[I][j]);
			a15= -4.0* MULT(VL[I][i],VL[I][j]);
			a16_0=MULT(CDD[j][i],VL[I][j])/CD1[j][i];
			a16=-1.5*a16_0*a16_0;
			a17= 0.5* MULT(CDD[i][j],PER0[j]);
			a10=(1.0+(a11+a12+a13+a14+a15+a16+a17)/(c*c));
			for(N=1;N<=3;N++)DIRECT[i][j][N]=DIRECT[i][j][N]*a10;
			}
		}
		}
	
		for (i=11;i<=NBODY;i++){
			for(N=1;N<=3;N++)PER[I][i][N]=0.0;
			for( j=0;j<=NBODY;j++){
				if(i  !=  j){
				for(N=1;N<=3;N++)PER[I][i][N]=PER[I][i][N]+DIRECT[i][j][N];
				}
		}
	}

// ΐ_x@Q

		for (i=11;i<=NBODY;i++){
			for( j=0;j<=NBODY;j++){
				if(i  !=  j){
					for(N=1;N<=3;N++)a21[N]=(4.0*VL[I][i][N]-3.0*VL[I][j][N]);
					for(N=1;N<=3;N++){
						a22[N]=MULT(CDD[j][i],a21);
						a20[N]=U[i][j]/CD2[i][j]*a22[N]*(VL[I][i][N]-VL[I][j][N]);
						PER[I][i][N]=PER[I][i][N]+a20[N]/(c*c);
					}			
				}
		}
	}

// ΐ_x@R

		for (i=11;i<=NBODY;i++){
			for( j=0;j<=NBODY;j++){
				if(i  !=  j){
					for(N=1;N<=3;N++){
						a30[N]=3.5*U[i][j]*PER0[j][N];
						PER[I][i][N]=PER[I][i][N]+a30[N]/(c*c);
					}			
				}
		}
	}

// d͌ʂ̌vZ	(NG(NonGravity)tO"1"̏ꍇ)
	if(NG==1){	

//      Original(Catalogue of Cometary Orbits 1997(12th)) 
//		if(                jd<2308251.5){A1= 0.28;A2=0.0150;}//1607
//		if(jd>2308251.5 && jd<2335645.5){A1=-0.01;A2=0.0155;}//1607-1682
//		if(jd>2335645.5 && jd<2363584.5){A1= 0.11;A2=0.0157;}//1682-1758
//		if(jd>2363584.5                ){A1= 0.04;A2=0.0155;}//1758-

//      CFinal
//		if(                    EPOCH<=1857710.5){A1= 0.283;A2=0.0150;}//-374
		if(                    EPOCH<=1857710.5){A1= 0.2827;A2=0.0150;}//-374 //2015/05/28 revised
		if( EPOCH>1857710.5 && EPOCH<=2026830.5){A1= 0.260;A2=0.0150;}//373-837
		if( EPOCH>2026830.5 && EPOCH<=2321979.5){A1= 0.280;A2=0.0150;}//837-1644
		if( EPOCH>2321979.5                    ){A1= 0.070;A2=0.0155;}//1644-

		NonGravity( I, 16 , A1, A2, NGr, CD, VL, CD1);
		for(N=1;N<=3;N++)PER[I][16][N]=PER[I][16][N]+NGr[N];
	}
	
}

//*********************************************************************
// z/f/̈ʒuExf[^DE431t@Cǂݍރ[`
//*********************************************************************

void DE_data(FILE *fp_Bin, double EPOCH ,int I, double CD[NIDAY][MAXN][4], double VL[NIDAY][MAXN][4])
{

    int Planet, i;
	Position Eph;
  
//
//                 PLANET NUMBER                                           |
//                 1 = MERCURY         8 = NEPTUNE                         |
//                 2 = VENUS           9 = PLUTO                           |
//                 3 = EARTH          10 = MOON                            |
//                 4 = MARS           11 = SUN                             |
//                 5 = JUPITER                                             |
//                 6 = SATURN                                              |
//                 7 = URANUS                                              |
//

	 for(i=0;i<=10;i++){
	 Planet=i;
	 if(i==0)Planet=11;
	 Ephemerides( fp_Bin,EPOCH,Planet,&Eph);//SđznS̈ʒuǂݍ

//   ʒu
	 CD[I][i][1]=Eph.x;
	 CD[I][i][2]=Eph.y;
	 CD[I][i][3]=Eph.z;
//   x
	 VL[I][i][1]=Eph.vx;
	 VL[I][i][2]=Eph.vy;
	 VL[I][i][3]=Eph.vz;
	 }

}
/*******************************************************************************/
/*                      ̌vZ                                             */
/*                                                                             */
/*               gpԂnW(LST)ȂF LST=1                         */
/*               gpԂnώ(LMT)ȂF LST=0                         */
/*******************************************************************************/

void Calendar( double juday, double *year,double *month,double *day,double *hour,int LST,double longitude)
{
	double flag,Z,Alfa,A,B,C,D,E,F,Day0;
	
	flag = 1;

	if (longitude<0 ){
		longitude = - longitude;
		flag=-1.0;
	}
	
	if (LST==1) juday =  juday +  flag*(double)(int)(longitude /15.0+0.5)/24.0;
		else    juday =  juday +  flag*longitude /15.0/24.0	;
		
	juday = juday + 0.5;
	Z = (double)(int)(juday);
	F = juday - Z;

	if (Z < 2299161.0) A = Z;
		else { 
			Alfa = (double)(int) ((Z - 1867216.25)/36524.25);
			A = Z + 1 + Alfa - (double)(int) (Alfa/4.0);}

	B = A + 1524;
	C = (double)(int) ((B-122.1)/365.25);
	D = (double)(int) (365.25 * C);
	E = (double)(int) ((B-D)/30.6001);

	Day0 = B - D - (double)(int)(30.60001*E) + F;
	*day = (double)(int)(Day0);
	*hour= F*24.0;
	if(E<14.0) *month = E-1.0;
	if(E==14.0 || E==15.0)	 *month = E- 13.0;
	if(*month>2.0) *year=C-4716;
	if(*month==1.0 || *month==2.0) *year = C - 4715;
}

